from SimulatorFramework import TileType
from SimulatorFramework import Frontier
import wx

class RobinsonTile(TileType):
    def __init__(self, name, nbrMatches, imgFile, tileWidth, tileHeight):
        TileType.__init__(self, name, tileWidth, tileHeight)
        self.matches = nbrMatches

        img = None
        if not imgFile is None:
            try:
                img = wx.Image(imgFile, wx.BITMAP_TYPE_TIF).ConvertToBitmap()
            except:
                img = None

        if (img is None) or (img.Width > 1000):
            bmp = wx.Bitmap(self.width-20, self.height-20)
            dc = wx.MemoryDC()
            dc.SelectObject(bmp)
            dc.Clear()
            colorStr = "Red"
            if img is None:
                colorStr = "Blue"
            else:
                #globalApp.OutputMessage("WARNING:  Invalid tile image file '" + imgFile + "'")
                print("WARNING:  Invalid tile image file '" + imgFile + "'")
            color = wx.TheColourDatabase.Find(colorStr)
            brush = wx.Brush(color)
            dc.SetBrush(brush)
            dc.DrawCircle(self.width/2, self.height/2, (self.width-40)/2)
            dc.SelectObject(wx.NullBitmap)
            img = bmp.ConvertToImage()
        else:
            img = img.ConvertToImage()
            #img = img.Scale(self.sideLen, self.sideLen, wx.IMAGE_QUALITY_HIGH)
            img = img.Scale(self.width, self.height, wx.IMAGE_QUALITY_HIGH)
            #img = img.Rotate(math.radians(90), (48, 48))
        img = wx.Bitmap(img)
        self.img = img
        
    def DrawAtLocation(self, xPixel, yPixel, pdc):
        pdc.DrawBitmap(self.img, xPixel, yPixel)


class RobinsonFrontierLocation(Frontier.FrontierLocation):
    def __init__(self, coords, fittingTypeNames):
        Frontier.FrontierLocation.__init__(self, coords, fittingTypeNames)
        self.isGrowthLoc = False
        if type(fittingTypeNames) is set and len(fittingTypeNames) > 1:
            self.isGrowthLoc = True
            
